# -*- Mode: Python; tab-width: 4 -*-

import fcntl
import FCNTL
import coro
import os

# make a file descriptor act like a socket for the purposes of
# the coro i/o scheduler.  this lets us fire up an interpreter
# on stdin/stdout.

class coro_fd:

	def __init__ (self, fd):
		flags = fcntl.fcntl (fd, FCNTL.F_GETFL, 0)
		flags = flags | FCNTL.O_NONBLOCK
		fcntl.fcntl (fd, FCNTL.F_SETFL, flags)
		self._fileno = fd

	def fileno (self):
		return self._fileno

	def __repr__ (self):
		return '<coro_fd fd=%d at %x>' % (self._fileno, id(self))

	def wait_for_read (self):
		me = coro.current_thread()
		coro.read_set[self._fileno] = me
		return me.yield()

	def wait_for_write (self):
		me = coro.current_thread()
		coro.write_set[self._fileno] = me
		return me.yield()

	def recv (self, buffer_size):
		self.wait_for_read()
		return os.read (self._fileno, buffer_size)

	_max_send_block = 64 * 1024

	def send (self, data):
		old = ld = len(data)
		while ld:
			self.wait_for_write()
			block = min (ld, self._max_send_block)
			start = old-ld
			end = start + block
			n = os.write (self._fileno, data[start:end])
			ld = ld - n
		return old

	read = recv
	write = send

	_closed = 0
	def close (self):
		if not self._closed:
			self._closed = 1
			os.close (self._fileno)

	def __del__ (self):
		self.close()

def repl():
	b = backdoor.backdoor (coro_fd(0), line_separator='\n')
	b.read_eval_print_loop()

if __name__ == '__main__':
	import backdoor
	cfd = coro_fd (0)
	coro.spawn (repl)
	coro.event_loop (30.0)
