# -*- Mode: Python; tab-width: 4 -*-

import coro
import coro_fd
import os
import sys
import string

# A version of 'popen2' that works in the coro world; i.e. reading
# from a subprocesses that would block will cause a yield().

def spawn_sub_process (cmd):
	if type(cmd) == type(''):
		cmd = ['/bin/sh', '-c', cmd]
	p2cread, p2cwrite = os.pipe()
	c2pread, c2pwrite = os.pipe()
	errout, errin = os.pipe()
	pid = os.fork()
	if pid == 0:
		# Child
		os.close(0)
		os.close(1)
		if os.dup(p2cread) <> 0:
			sys.stderr.write ('popen2: bad read dup\n')
		if os.dup(c2pwrite) <> 1:
			sys.stderr.write ('popen2: bad write dup\n')
		os.close(2)
		if os.dup(errin) <> 2:
			pass
		try:
			os.execvp(cmd[0], cmd)
		finally:
			os._exit(1)
		# Shouldn't come here, I guess
		os._exit(1)
	else:
		# Parent
		os.close(p2cread)
		os.close(c2pwrite)
		os.close(errin)
		# <stdout>, <stdin>, <stderr>
		cfd = coro_fd.coro_fd
		return cfd(c2pread), cfd(p2cwrite), cfd(errout), pid


def test (s='ls -lR /usr/src/linux/net'):
	fo, fi, fe, pid = spawn_sub_process (s)
	while 1:
		block = fo.read(8192)
		if not block:
			break
		else:
			print block
